set_config("toolchain", "clang")
add_rules("mode.debug", "mode.release")
set_languages("c++20")

target()
add_linkdirs("$(shell brew --prefix)/lib", "$(shell brew --prefix)/opt/llvm/lib")
add_includedirs(
	"/usr/local/include",
	"$(shell brew --prefix)/include/",
	"$(shell brew --prefix)/opt/llvm/include/c++/v1"
)
add_cxxflags(
	"-fmodules",
	"-fcxx-modules",
	"-fmodule-maps",
	"-fimplicit-module-maps",
	"-fbuiltin-module-map",
	"-fmodule-map-file=$(shell brew --prefix)/include/c++/v1/module.modulemap",
	"-fvisibility=default",
	{ force = true }
)
add_ldflags("-fuse-ld=mold", "-nostdlib++", "-stdlib=libc++", "-lc++")
target_end()

target("trouble")
    set_kind("shared")
    add_files("src/*.cpp", "src/*.mpp")

target("test")
    set_kind("binary")
    add_files("test/*.cpp")
    add_deps("trouble")